var Cloud = require("ti.cloud"),
    Helper = require("../helper");

var Users = Cloud.Users,
    doneEvent = Helper.doneEvent,
    overallPassKey = Helper.overallPassKey,
    overallTestsKey = Helper.overallTestsKey,
    dummyUser = Helper.dummyUser,
    dummyPassword = Helper.dummyPassword;
    
var testsPassed = 0,
	totalTests = 0,
	userId = undefined;

function done() {
	Ti.API.info("DONE testing Cloud.Users");
	var stats = "Passed: " + testsPassed + "\n" + "Total: " + totalTests;
	Ti.API.info(stats);

	var stats = {};
	stats[overallPassKey] = testsPassed;
	stats[overallTestsKey] = totalTests;
	Ti.App.fireEvent(doneEvent, stats);
}

exports.run = function() {
    var testMsg = "Testing Cloud.Users ...";
	Ti.API.info(testMsg);

	totalTests = 0;
	testsPassed = 0;
	
	var delay = 0;	
	setTimeout(createUsers, delay);
	setTimeout(removeUsers, delay += 3000);
	setTimeout(done, delay += 3000);
	
	return testMsg;	
};

function createUsers() {
	totalTests++;
	Ti.API.info("Called Users.create");

	var data = {
		username: dummyUser[0],
		email: dummyUser[0] + "@gmail.com",
		first_name: dummyUser[0],
		last_name: dummyUser[0],
		password: dummyPassword[0],
		password_confirmation: dummyPassword[0]
	};

	Users.create(data, function(evt) {
		if(evt.success) {
			testsPassed++;

			var successMsg = "Successfully called Users.create";
			Ti.API.info(successMsg);
			Ti.API.info(JSON.stringify(evt, null, "\t"));
			
			userId = evt.users[0].id;
		} 
		else {
			var errMsg = "Failed to call Users.create";
			Ti.API.info(errMsg);
			Ti.API.info(JSON.stringify(evt, null, "\t"));
		}

	});
}

function removeUsers() {
	totalTests++;
	Ti.API.info("Called Users.remove");

    Users.remove({}, function(evt) {

        if (evt.success) {
            testsPassed++;

            var successMsg = "Successfully called Users.remove";
            Ti.API.info(successMsg);
            Ti.API.info(JSON.stringify(evt, null, "\t"));
        } 
        else {
            var errMsg = "Failed to call Users.remove";
            Ti.API.info(errMsg);
            Ti.API.info(JSON.stringify(evt, null, "\t"));
        }
    }); 
}